##############################
#   Defining parameters  
##############################

α = 0.36
δ   = 0.025
γ = 1.0001

ϕ = .5

if γ==1.0
    Uvv(X) = log.(X)+10
    Ulinv(X) = exp.(X - 10.)
else
    Uvv(X) =  (X.^(1-γ)-1)./(1-γ) +10.
    Ulinv(X) = (1. +(1-γ).* ( X - 10.) ).^(1/(1-γ))
end

#ns     = 7
ns     = 7
na     = 50
rho    = 0.9695^0.25; #Persistence component of income
Ve     = 0.2*(1+rho)/2
sige   = sqrt(Ve);

#rho    = 0.990; #Persistence component of income
#Ve     = 0.099^2
#sige   = sqrt(Ve);

pers = 0.9695
sigma2 = 0.0384

rho    = pers^0.25; #Persistence component of income
sige = ((sigma2*(1-pers^0.5)/(1-pers^2))^0.5)/(1+ϕ)
#alternative process
#rho = 0.9730
#sige = 0.1280


mc     = rouwenhorst(ns,rho,sige)
#mc.state_values = mc.state_values/(1+ϕ)
#mc.state_values = mc.state_values
endow  = exp.(mc.state_values)
#######redifining the transition Matrix
#### I put remaining weight on the diagonal
Trans = collect(mc.p')
Trans[findall(x->x<=5*10^-5,Trans)].=0
for i =1:ns
    Trans[i,i] = Trans[i,i]+ (1 - sum(Trans,dims=1)[i])
end
#Trans  = Matrix(mc.p')

#stdist = stationary_distributions(mc)
stdist = (Trans^100000)[:,1]

Transv = vec(Trans) #  Trans = reshape(Transv,size(Trans)[1],size(Trans)[2])
amin = 1e-9
amax = 3000.0 #10000
curv = 4

#labor market
Su            = 0.0583;      # Average unemployment rate
Se            = 1 - Su


PHI = .42        #replacement rate #0.47

τ   = Su*PHI/Se # replacement rate

FRR             = 0.87862;
pie = zeros(Float64,2,2) #final, initial
pie[2,1] = FRR;
pie[1,1] = 1-pie[2,1];
pie[1,2] = (1-pie[1,1])*Su/Se;
pie[2,2] = 1-pie[1,2];
Transe = vec(pie)

#Renormalization
lbar   = dot(stdist,endow .^(1.0 + ϕ))
states = endow./ (lbar^(1/(1+ϕ)))  #I must have  s.*y^(1+phi)==1
vstan = [Su.*stdist;Se*stdist]; # vector of stationary distribution


KsY = 10.26
β = 0.99
R = 0.9867*1/β

wtemp = (1-α)*( (R - (1-δ))/α )^(α/(α-1))
χ = (1/(3*Se))^(1/ϕ)/((1-τ)*wtemp)
#χ = (1^(1/ϕ))/((1-τ)*wtemp)
 CC = Se*(χ*(1-τ))^ϕ
Ltemp = CC*wtemp^ϕ
K0 = Ltemp*( (R - (1-δ))/α )^(1/(α-1))

#First pass
N = 2
K0 = 8.0
AA0,pol0 = AiyagariEGM(K0,ns,Transv,Transe,states,amin,amax,curv,ϕ,χ,β,α,δ,γ,PHI,τ,Se,na,na);
β