% in this version the labor disutility of unemployed is time-varying

warning('off','all');
load todynare

%%

Ntot        = proj.Nbin;
Ny          = proj.ns;
Size        = proj.Size;
apv         = proj.ae./Size; % end-of-period per capita
atv         = proj.at./Size; % beginning-of-period per capita
Transp      = proj.Transp;
Transpu     = proj.Transu'; % it is  Transp' in this case
TranspL     = diag(1./Size)*Transp*diag(Size);

thres       = 0*10^-6;% threshold to consider 0 (not to have too many equations)


% Technical oefficient to insure BK condition
coefS       = 1.0;
coefa       = 1;%0.9626941;
coefE       = 1;
%coefp       = 1.0123;
coefp       = 1.0;% time-varying PHI
%coefp       = 1.01;% to have a fixed PHI

phil        = phi; % phi of labor supply, not to get confused 
xsil        = xsi; % xsi of labor supply, not to get confused 
sigma       = gamma; % change of notaiton here, concavity of utility function
Uc          = @(C,l) (C - (l.^(1+1/phil))/(xsil*(1+1/phil))).^(-sigma);
if sigma == 1
    U          = @(C,l) log(C - (l.^(1+1/bewley.phil))/(xsil*(1+1/phil)));
else
    U          = @(C,l) (((C - (l.^(1+1/phil))/(xsil*(1+1/phil)))).^(1-sigma))/(1-sigma);
end

rho_u       = 0.95;
sigma_u     = 0.00312;

fid         = fopen('Dynare_ramsey.mod', 'w') ;
formatSpec  = '%16.12f';

%%%%%%%%%
% in this version I consider the given transition on the labor market and
% correlation from the regressions
means       = Transe(1,2);
meanf       = Transe(2,1);




str         = ['var\n'] ; fprintf(fid, str);
str         = ['r w Z K GDP PHI L U tau u Pop  s f C Ce Cu ratio LGDP LC LI LL Lw Lwe Lwu\n'] ; fprintf(fid, str);
str         = ['Sum2 AU AE Sum1 DIF cec cuc Ku Incu kuc dY dK dL dC du Ineq df dU dphi I Kp\n'] ; fprintf(fid, str);

%str         = ['r w Z K GDP L U tau u Pop DIF PHI s f C Ce Cu ratio\n'] ; fprintf(fid, str);






for i = 1:Ntot
    str     = ['ap',num2str(i),' '] ; fprintf(fid,str);    
    str     = ['at',num2str(i),' '] ; fprintf(fid, str);           
    str     = ['c',num2str(i),' '] ; fprintf(fid, str);  
    str     = ['S',num2str(i),' '] ; fprintf(fid, str);
    str     = ['lambda',num2str(i),' '] ; fprintf(fid, str);  
    str     = ['glambda',num2str(i),' '] ; fprintf(fid, str);
    str     = ['PSI',num2str(i),' '] ; fprintf(fid, str);
    if mod(i,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;    
end;
for i = 1:Ny
    str     = ['l',num2str(i),' '] ; fprintf(fid, str);      
    if mod(i,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;    
end;
str         = ['; \n\n'] ; fprintf(fid, str);

str         = ['varexo eps; \n\n'] ; fprintf(fid, str);
str         = ['parameters\n'] ; fprintf(fid, str);
str         = ['beta alpha abar delta sigma rho_u xsil phil   x\n'] ; fprintf(fid, str);
str = ['; \n\n'] ; fprintf(fid, str);

l0          = 0;
abar        = abar;
 
str         = ['alpha','   = ',num2str(alpha),';\n']; fprintf(fid, str); 
str         = ['beta ','   = ',num2str(beta),';\n']; fprintf(fid, str); 
str         = ['abar ','   = ',num2str(abar),';\n']; fprintf(fid, str); 
str         = ['sigma','   = ',num2str(sigma),';\n']; fprintf(fid, str); 
str         = ['rho_u','   = ',num2str(rho_u),';\n']; fprintf(fid, str); %HERE
str         = ['delta','   = ',num2str(delta),';\n']; fprintf(fid, str);
str         = ['l    ','   = ',num2str(l0),';\n']; fprintf(fid, str);
str         = ['phil ','   = ',num2str(phil),';\n']; fprintf(fid, str);
str         = ['xsil ','   = ',num2str(xsil),';\n']; fprintf(fid, str);
str         = ['x ','      = ',num2str(0),';\n']; fprintf(fid, str);


%str     = ['PHI  ','   = ',num2str(proj.PHI),';\n']; fprintf(fid, str);

str = ['\n\n'] ; fprintf(fid, str);
ev = cell2mat(etype); %vector of employment type by bin
yv = cell2mat(yetype); % vector of productivity type by bin
yv = mod(yv-1,Ny)+1;

indc=indcc;
%indc    = find(proj.CC>= Th); %credit constraind agents
%indnc = find(proj.CC <Th); 

%%  

str     = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str); 
str     = ['\n\n'] ; fprintf(fid, str);    

str     = ['model;\n\n']; fprintf(fid, str);
equa    = 1;
%%%%%%%%%%%%%%%%% LABOR SUPPLY %%%%%%%%%%%%%
for i = 1:Ny
    str = ['l',num2str(i),' =  (',num2str(states(i)*xsil,formatSpec),'*(1-tau)*w)^',num2str(phil),';']; fprintf(fid, str);
    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;

%%%%%%%%%%%%%%%%% BUDGET CONSTRAINTS %%%%%%%%%%%%%
for i = 1:Ntot/2
    str = ['c',num2str(i),'+ap',num2str(i), ' = PHI*w*',num2str(states(yv(i)),formatSpec),'*l',num2str(yv(i)),' + (1+r)*at',num2str(i),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;
for i = Ntot/2+1:Ntot
    str = ['c',num2str(i),'+ap',num2str(i), ' = (1-tau)*w*',num2str(states(yv(i)),formatSpec),'*l',num2str(yv(i)),'+ (1+r)*at',num2str(i),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;

str = ['\n\n']; fprintf(fid, str);
%%%%%%%%%%%%%%%%  WEALTH TRANSITION  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1:Ntot/2
   if Size(i)>thres 
     str = ['S',num2str(i),'*at',num2str(i),' = (\n']; fprintf(fid, str);
     emp = 1;
     for j=1:Ntot/2 % u to u
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+ ',num2str(coefa*Transp(i,j)/(1-meanf),formatSpec),'*(1-f)*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);            
             emp = 0;
         end;
     end;
     for j = Ntot/2+1:Ntot % e to u
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefa*Transp(i,j)/means,formatSpec) ,'*s*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
      if emp==1
       str = ['S',num2str(i),'*',num2str(atv(i),formatSpec)]; fprintf(fid, str);
      end
     
     str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      
   else
       str = ['at',num2str(i),' = ',num2str(atv(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
   end
end;    
for i = Ntot/2+1:Ntot
   if Size(i)>thres 
       str = ['S',num2str(i),'*at',num2str(i),' = (\n']; fprintf(fid, str);
     % str    = ['S',num2str(i),'*at',num2str(i),' = (\n']; fprintf(fid, str);
      emp = 1;
     for j = 1:Ntot/2 % u to e
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefa*Transp(i,j)/meanf,formatSpec),'*f*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp =0;
         end;
     end;
     for j = Ntot/2+1:Ntot %e to E
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefa*Transp(i,j)/(1-means),formatSpec) ,'*(1-s)*S',num2str(j),'(-1)*ap',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
     if emp==1
       str = ['S',num2str(i),'*',num2str(atv(i),formatSpec)]; fprintf(fid, str);
      end
     str = [');']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;     
   else
       str    = ['at',num2str(i),' = ',num2str(atv(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;           
   end
end;
str = ['\n\n']; fprintf(fid, str);
%%%%%%%%%% EULER EQUATIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
str     = ['%%%%%%%% equation ',num2str(equa),': Euler\n\n']; fprintf(fid, str);
 %xsiE.*Ucv - beta*(1+r)*TranspEc*(xsiE.*Ucv) - nupv
 
 
%   for i = 1:Ntot
%       str = ['ap',num2str(i),' = abar;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;       
%  end;

for i = 1:length(indc)
     str = ['ap',num2str(indc(i)),' = ',num2str(apv(indc(i)),formatSpec) ,';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;       
end;


for k = 1:length(indnc);
    i = indnc(k);
    threse = 0;
    if i <= Ntot/2
       if Size(i)>thres
           str = [num2str(proj.xsiUc(i),formatSpec),'*(c',num2str(i),'-( ((l',num2str(yv(i)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma  = beta*(1+r(+1))*(\n'];fprintf(fid, str);        
           for j = 1:Ntot/2 % u to u and e
                 if (Transpu(i,j)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                     str = ['+',num2str(Transpu(i,j)*proj.xsiUc(j)/(1-meanf),formatSpec),'*(1-f(+1))*(c',num2str(j),'(+1)-(((l',num2str(yv(j)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str); % stay unemployed
                 end;
           end;
           for j = Ntot/2+1:Ntot % u to u and e
                 if (Transpu(i,j)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                    str = ['+',num2str(Transpu(i,j)*proj.xsiUc(j)/meanf,formatSpec),'*f(+1)*(c',num2str(j),'(+1)-(l',num2str(yv(j)),'(+1)^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str);% becme employed          
                 end;
           end;
            str = ['+',num2str(proj.Res(i),formatSpec),');']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;     
       else
            str = ['c',num2str(i),' = ',num2str(proj.conso(i)/Size(i),formatSpec),';']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;       
      end
    end;
     if i > Ntot/2
       if Size(i)>thres
           str = [num2str(proj.xsiUc(i),formatSpec),'*(c',num2str(i),'-( (l',num2str(yv(i)),')^(1+1/phil))/(xsil*(1+1/phil)))^-sigma   = beta*(1+r(+1))*(\n'];fprintf(fid, str);
           for j=1:Ntot/2
                 if (Transpu(i,j)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                     str = ['+',num2str(Transpu(i,j)*proj.xsiUc(j)/means,formatSpec),'*s(+1)*(c',num2str(j),'(+1)-(((l',num2str(yv(j)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str); % stay unemployed
                 end;
           end;
           for j = Ntot/2+1:Ntot
                 if (Transpu(i,j)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                     str = ['+',num2str(Transpu(i,j)*proj.xsiUc(j)/(1-means),formatSpec) ,'*(1-s(+1))*(c',num2str(j),'(+1)-(l',num2str(yv(j)),'(+1)^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str);% becme employed
                 end;
           end;
             str = ['+',num2str(proj.Res(i),formatSpec),');']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   
       else
            str    = ['c',num2str(i),' = ',num2str(proj.conso(i)/Size(i),formatSpec),';']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
       end
    end;  
end;


%%%%%%%%%%%%%%%%%%%%%%%%%  SHARES  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 str    = [' %%%%%%%% equation ',num2str(equa),': Shares \n\n']; fprintf(fid, str);
 %    proj.lambda -  proj.Transp*proj.lambda  = 0
thres2 = thres;
%thres=0;
for i = 1:Ntot/2 
    emp = 1;
     str    = ['S',num2str(i),' = \n']; fprintf(fid, str);
     for j=1:Ntot/2
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefS*Transp(i,j)/(1-meanf),formatSpec),'*(1-f)*S',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end; 
     end;
     for j = Ntot/2+1:Ntot
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefS*Transp(i,j)/means,formatSpec) ,'*s*S',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
     
     if emp ==1   % case where small bin with no transition
          str    = [num2str(Size(i),formatSpec) ,';']; fprintf(fid, str);
     else
          str = [';']; fprintf(fid, str);   
     end;
     str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   
end;     
for i = Ntot/2+1:Ntot
    emp = 1;
     str    = ['S',num2str(i),' = ']; fprintf(fid, str);
     for j = 1:Ntot/2
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefS*Transp(i,j)/meanf,formatSpec),'*f*S',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
     for j = Ntot/2+1:Ntot
         if Transp(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefS*Transp(i,j)/(1-means),formatSpec),'*(1-s)*S',num2str(j),'(-1)\n']; fprintf(fid, str); 
             emp = 0;
         end;
     end;
    
      if emp ==1   % case where small bin with no transition
           str    = [num2str(Size(i),formatSpec) ,';']; fprintf(fid, str);
      else
           str = [';']; fprintf(fid, str);
      end;
      str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   
end; 
str = ['\n\n']; fprintf(fid, str);
thres = thres2;
%%%%%%%%%%%%%%%%%%%%%  AGGREGATIONS  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
str = [' %%%%%%%% equation ',num2str(equa),': Aggretations \n\n']; fprintf(fid, str);
str = ['Pop = ']; fprintf(fid, str);
for i = 1:Ntot
     str    = ['+S',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  
str = ['K = ']; fprintf(fid, str);
for i = 1:Ntot
     str    = ['+S',num2str(i),'*ap',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  

str = ['Ku = ']; fprintf(fid, str);
for i = 1:Ntot/2
     str    = ['+S',num2str(i),'*ap',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;          fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   


str = ['L = (1-U)*((xsil*(1-tau))^phil)*(((1 - alpha)*(Z*(K(-1)/((1-U)*(xsil*(1-tau))^phil))^alpha))^(phil/(1+phil*alpha))); ']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;
str = ['U = (1-f)*U(-1)+(1-U(-1))*s;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;

str = ['Cu = ']; fprintf(fid, str);
for i = 1:Ntot/2
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;



str = ['Incu = (1/U)*( ']; fprintf(fid, str);
for i = 1:Ntot/2
      %str    = ['+S',num2str(i),'*(0*PHI*w*',num2str(bewley.ex(yv(i)),formatSpec),'*l',num2str(yv(i)),' + (1+r)*at',num2str(i),')']; fprintf(fid, str);
      str    = ['+S',num2str(i),'*(1+r)*at',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [');'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;



str = ['Ce = ']; fprintf(fid, str);
for i = Ntot/2+1:Ntot
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'];fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;

str = ['C =  GDP - I;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
str = ['ratio = cuc/cec;'] ;      fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;
str = ['cec = Ce/(1-U);'] ;     fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; 
str = ['cuc = Cu/U;'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; 
str = ['kuc = Ku/U;'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; 


str = ['w = (1 - alpha)*(Z^(1/(1-alpha)))*((r + delta)/alpha)^(alpha/(alpha-1));']; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['(r + delta)/(alpha*Z) = (K(-1)/L)^(alpha-1);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
%str = ['tau =',num2str(bewley.wage),'*PHI*U/(w*(1-x)*L);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   

str = ['Z = 1+u;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['u = rho_u*u(-1)+eps;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['GDP = Z*(K(-1)^alpha)*(L^(1-alpha));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;   

str = ['Kp = K(-1);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['I = Kp(+1) - (1 - delta)*Kp;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   


str = ['f =  6*u+',num2str(meanf,formatSpec),';\n'] ; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  
str = ['s =',num2str(means,formatSpec),';\n'] ; fprintf(fid, str);  equa = equa+1;  


thres = 1e-10;



str = ['% %%%%%%%%%%%%%%%%%%%%%%%% Definition glambda']; fprintf(fid, str);
for i = 1:Ntot/2
   if Size(i)>thres 
     str    = ['glambda',num2str(i),'= (\n']; fprintf(fid, str);
     emp = 1;
     for j=1:Ntot/2
         if TranspL(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+ ',num2str(coefE*TranspL(i,j)/(1-meanf),formatSpec),'*(1-f)*lambda',num2str(j),'(-1)\n']; fprintf(fid, str);  
             emp = 0;
         end;
     end;
     for j = Ntot/2+1:Ntot
         if TranspL(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefE*TranspL(i,j)/means,formatSpec) ,'*s*lambda',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
     if emp == 1
         str = [num2str(plans.lambdat(i),formatSpec)]; fprintf(fid, str);
     end;
     
     str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      
   else
     str    = ['glambda',num2str(i),' = ',num2str(plans.lambdat(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
   end
end;    
for i = Ntot/2+1:Ntot
   if Size(i)>thres 
     str    = ['glambda',num2str(i),'= (\n']; fprintf(fid, str);
     emp = 1;
     for j=1:Ntot/2
         if TranspL(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+ ',num2str(coefE*TranspL(i,j)/meanf,formatSpec),'*f*lambda',num2str(j),'(-1)\n']; fprintf(fid, str);   
             emp = 0;
         end;
     end;
     
     for j = Ntot/2+1:Ntot
         if TranspL(i,j)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
             str = ['+',num2str(coefE*TranspL(i,j)/(1-means),formatSpec) ,'*(1-s)*lambda',num2str(j),'(-1)\n']; fprintf(fid, str);
             emp = 0;
         end;
     end;
     if emp == 1
         str = [num2str(plans.lambdat(i),formatSpec),'*S',num2str(i)]; fprintf(fid, str);
     end;
     str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      
   else
     str    = ['glambda',num2str(i),'= ',num2str(plans.lambdat(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  
 
   end
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DEFINITION PSI

str = [' %%%%%%%% equation ',num2str(equa),': Definition PSI \n\n']; fprintf(fid, str);

for i = 1:Ntot/2
     str    = ['PSI',num2str(i),' = ',num2str(proj.xsiU(i),formatSpec),' * ((c',num2str(i),')-(((l',num2str(yv(i)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma']; fprintf(fid, str);
     str    = [' - (lambda',num2str(i),'-(1+r)*glambda',num2str(i),')*',num2str(proj.xsiUc(i),formatSpec),'*(-sigma)*(c',num2str(i),'-( ((l',num2str(yv(i)),'))^(1+1/phil))/(xsil*(1+1/phil)))^(-sigma-1)']; fprintf(fid, str);
     str    = [';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;      
end; 
for i = Ntot/2+1:Ntot
     str    = ['PSI',num2str(i),' = ',num2str(proj.xsiU(i),formatSpec),' * (c',num2str(i),'-(l',num2str(yv(i)),'^(1+1/phil))/(xsil*(1+1/phil)))^-sigma']; fprintf(fid, str);
     str    = [' - (lambda',num2str(i),'-(1+r)*glambda',num2str(i),')*',num2str(proj.xsiUc(i),formatSpec),'*(-sigma)*(c',num2str(i),'-( (l',num2str(yv(i)),')^(1+1/phil))/(xsil*(1+1/phil)))^(-sigma-1)']; fprintf(fid, str);
     str    = [';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;      
end; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% EULER PSI
% 
% for i = 1:Ntot
%     for j = 1:Ntot % be very careful with indexes
%         PIpsi(i,j)    = beta*(1 + FK)*proj.Transpa(j,i) +  ... % be careful about the definition of proj.Transpa
%            + beta*alpha*(1-alpha)/((1+phil*alpha)*L)*( (K/L)^(alpha-1))*( (1-tau)*(ev(j)-1) + ((1 - Urec)/Urec)*tau*(1+phil)*(2 - ev(j)) )*...
%             S(j)*lle(yv(j))*bewley.ex(yv(j));
%     
%           %  + (beta*alpha*(1-alpha)/L)*( (K/L)^(alpha-1))* ( ((1 - Urec)/Urec)*(2 - ev(j)) )*... 
%            % S(j)*lle(yv(j))*bewley.ex(yv(j));
%          % ( (1-tau)*(ev(j)-1) + ((1 - Urec)/Urec)*tau*(1+phil)*(2 - ev(j)) )*...
%     end;
% end;
% PIL = proj.Transpu';



str = ['\n  %%%%%%%% equation ',num2str(equa),': EULER PSI \n\n']; fprintf(fid, str);


str    = ['Sum2 = beta*alpha*(1-alpha)/((1+phil*alpha)*L)*((K(-1)/L)^(alpha-1))* ( (tau*(1+phil)*(1-x)*(1-U)/U)*(\n']; fprintf(fid, str);
for j=1:Ntot/2
         str = ['+PSI',num2str(j),'*S',num2str(j),'*l',num2str(yv(j)),'*',num2str(states(yv(j)),formatSpec)]; fprintf(fid, str);   
         if mod(j,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
         end;
 end;
 str = [')+']; fprintf(fid, str); 

 str    = ['  (1-tau)*(\n']; fprintf(fid, str);
for j=Ntot/2+1:Ntot
         str = ['+PSI',num2str(j),'*S',num2str(j),'*l',num2str(yv(j)),'*',num2str(states(yv(j)),formatSpec)]; fprintf(fid, str);   
         if mod(j,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
         end;
 end;
 str = [') );']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      


% for i = 1:Ntot
%       str = ['lambda',num2str(i),' = ',num2str(planner.lambda(i),formatSpec),';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;      
% end;


for i = 1:length(indc)
      str = ['lambda',num2str(indc(i)),' = 0;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;      
end;



for k=1:length(indnc)
    i = indnc(k);
  
    if i<=Ntot/2
           if Size(i)>thres 
             str    = ['PSI',num2str(i),' =   Sum2(+1)- (beta*alpha*(1-alpha)/(1+phil*alpha))*(1/L(+1))*((K/L(+1))^(alpha-2))*(Sum1(+1)*(1-U(+1))/(alpha*phil)) +  beta*(1+r(+1))*( \n']; fprintf(fid, str);
             for j=1:Ntot/2
                 if Transp(j,i)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
                     str = ['+ PSI',num2str(j),'(+1)*(1-f(+1))*',num2str(coefp*Transp(j,i)/(1-meanf),formatSpec)]; fprintf(fid, str);   
                     if mod(j,10)==0; %multiple de 10
                         str = ['\n'] ;         fprintf(fid, str);
                     end;
                 end;
             end;
             for j = Ntot/2+1:Ntot
                 if Transp(j,i)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
                    str = ['+ PSI',num2str(j),'(+1)*f(+1)*',num2str(coefp*Transp(j,i)/meanf,formatSpec)]; fprintf(fid, str);   
                    if mod(j,10)==0; %multiple de 10
                         str = ['\n'] ;         fprintf(fid, str);
                    end;
                 end;
             end;
             str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      
           else
               str    = ['lambda',num2str(i),' = ',num2str(plans.lambda(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  
           end
    else
        
        if Size(i)>thres 
             str    = ['PSI',num2str(i),' =   Sum2(+1)- (beta*alpha*(1-alpha)/(1+phil*alpha))*(1/L(+1))*((K/L(+1))^(alpha-2))*(Sum1(+1)*(1-U)/(alpha*phil)) +  beta*(1+r(+1))*( \n']; fprintf(fid, str);
             for j=1:Ntot/2
                 if Transp(j,i)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
                     str = ['+ PSI',num2str(j),'(+1)*s(+1)*',num2str(coefp*Transp(j,i)/means,formatSpec)]; fprintf(fid, str);   
                     if mod(j,10)==0; %multiple de 10
                         str = ['\n'] ;         fprintf(fid, str);
                     end;
                 end;
             end;
             for j = Ntot/2+1:Ntot
                 if Transp(j,i)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
                    str = ['+ PSI',num2str(j),'(+1)*(1-s(+1))*',num2str(coefp*Transp(j,i)/(1-means),formatSpec)]; fprintf(fid, str);   
                    if mod(j,10)==0; %multiple de 10
                         str = ['\n'] ;         fprintf(fid, str);
                    end;
                 end;
             end;
             str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      
           else
               str    = ['lambda',num2str(i),' = ',num2str(plans.lambda(i),formatSpec),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  
        end   
    end
end;    

str = ['\n\n']; fprintf(fid, str);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% OPTIMAL PHI
%  %str = ['0 = ']; fprintf(fid, str); 


%(1 - tau+phil*(alpha-tau))*(K(-1)/(L*U))*

str = ['AU = (1 - tau+phil*(alpha-tau))*(K(-1)/(L*U))*(']; fprintf(fid, str); % to set PHI constant
for i=1:Ntot/2
   if Size(i)>thres   
     str = ['+ S',num2str(i),'*PSI',num2str(i),'*l',num2str(yv(i)),'*',num2str(states(yv(i)),formatSpec)]; fprintf(fid, str);  
   end;
   if mod(i,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
   end;
end;
str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      
str = ['\n\n']; fprintf(fid, str);

%AE          = (1-tau)*K*sum(bewley.ex(yv).*lv'.*S.*PSI.*(ev'-1))/((1-Urec)*L);


str = ['AE = (1 - tau)*(K(-1)/((1-U)*L))*(']; fprintf(fid, str); % to set PHI constant
for i = Ntot/2+1:Ntot
   if Size(i)>thres   
     str = ['+ S',num2str(i),'*PSI',num2str(i),'*l',num2str(yv(i)),'*',num2str(states(yv(i)),formatSpec)]; fprintf(fid, str);  
   end;
   if mod(i,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
   end;
end;
str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      


%sum1        = alpha*phil*sum(S.*Glambda.*proj.xsiE.*proj.Ucv + PSI.*proj.a(:));

str = ['Sum1 = (alpha*phil/(1-U))*(']; fprintf(fid, str); % to set PHI constant
for i=1:Ntot
   if Size(i)>thres 
     str = ['+ S',num2str(i),'*PSI',num2str(i),'*at',num2str(i)]; fprintf(fid, str);    
   end;
   if mod(i,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
   end;
end;
str = ['\n'] ;         fprintf(fid, str);
for i=1:Ntot/2
   if Size(i)>thres 
     str = ['+ S',num2str(i),'*glambda',num2str(i),'*',num2str(proj.xsiUc(i),formatSpec),'*(c',num2str(i),'-( ((l',num2str(yv(i)),'))^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str);         
     
   end;
   if mod(i,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
   end;
end;
for i = Ntot/2+1:Ntot
 if Size(i)>thres % Does agent j reach agent i ? effective transition toward the bin (bi,yi)
     str = [' + S',num2str(i),'*glambda',num2str(i),'*',num2str(proj.xsiUc(i),formatSpec),'*(c',num2str(i),'-( (l',num2str(yv(i)),')^(1+1/phil))/(xsil*(1+1/phil)))^-sigma\n']; fprintf(fid, str);         
     
 end;
 if mod(i,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
   end;
end;
str = [');']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;      


str = ['DIF = Sum1 + AE - AU ;']; fprintf(fid, str);str = [' %% equation ',num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; % to set  PHI constant

str = ['DIF  = ',num2str(plans.Res,formatSpec) ,' ;']; fprintf(fid, str);str = [' %% equation ',num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; % to set  PHI constant

%str     = ['PHI  ','   = ',num2str(PHI),';\n']; fprintf(fid, str);str = [' %% equation ',num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; % to set  PHI constant


str = ['PHI = tau*(1-U)/U;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
% note when u is 1 it is already in percent

str = ['du = 100*u;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dY = 100*(GDP - steady_state(GDP))/steady_state(GDP);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dK = 100*(K - steady_state(K))/steady_state(K);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dC = 100*(C - steady_state(C))/steady_state(C);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dL = 100*(L - steady_state(L))/steady_state(L);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Ineq = 100*(ratio - steady_state(ratio))/steady_state(ratio);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['df = 100*(f- steady_state(f));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dU = 100*(U- steady_state(U));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['dphi = 100*(PHI- steady_state(PHI));']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   


str = ['LGDP = log(GDP);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LC   = log(C);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LI   = log(I);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LL   = log(L);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Lw   = log(w);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   

str = ['Lwu   = log(PHI*w);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Lwe   = log((1-tau)*w);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   





str = ['end;\n\n'] ; fprintf(fid, str);  



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str);   
str = ['\n\n'] ; fprintf(fid, str);    

%str = ['initval;\n\n'] ; fprintf(fid, str);    
str = ['steady_state_model;\n\n'] ; fprintf(fid, str);           
for i = 1:Ntot
    str = ['ap',num2str(i),' = ',num2str(apv(i),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['at',num2str(i),' = ',num2str(atv(i),formatSpec),';\n'] ; fprintf(fid, str);    
    str = ['c',num2str(i), ' = ',num2str(proj.conso(i)/Size(i),formatSpec),';\n'] ; fprintf(fid, str); 
    str = ['S',num2str(i), ' = ',num2str(Size(i),formatSpec),';\n'] ; fprintf(fid, str); 
    str = ['lambda',num2str(i), ' = ',num2str(plans.lambda(i),formatSpec),';\n'] ; fprintf(fid, str); 
    str = ['glambda',num2str(i), ' = ',num2str(plans.lambdat(i),formatSpec),';\n'] ; fprintf(fid, str); 
    str = ['PSI',num2str(i), ' = ',num2str(plans.psi(i),formatSpec),';\n'] ; fprintf(fid, str); 
end;

for i = 1:Ny
    str = ['l',num2str(i),' =  ',num2str(proj.Ls(Ny+i),formatSpec),';\n']; fprintf(fid, str);
end;

str = ['r = ', num2str(proj.R-1,formatSpec),';\n'] ; fprintf(fid, str);
str = ['K = ', num2str(proj.K,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Kp = ', num2str(proj.K,formatSpec),';\n'] ; fprintf(fid, str);
str = ['L = ', num2str(Ltot,formatSpec),';\n'] ; fprintf(fid, str);
str = ['w = ', num2str(proj.w,formatSpec),';\n'] ; fprintf(fid, str);
str = ['tau','    = ',num2str(tau,formatSpec),';\n\n']; fprintf(fid, str);
str = ['Z  = 1;\n\n']; fprintf(fid, str);
str = ['u  = 0;\n\n']; fprintf(fid, str);
str = ['GDP = Z*K^alpha*L^(1-alpha);\n']; fprintf(fid, str);
str = ['Pop = 1;\n']; fprintf(fid, str);


UU = sum(Size(1:Ntot/2));%'*states(yv(1:Ntot/2));

str = ['U = ',num2str(UU,formatSpec),';\n']; fprintf(fid, str);

% Lsp                      = [bewley.b*kron(proj.ls',ones(proj.Nbin,1)),kron(proj.ls',ones(proj.Nbin,1))];
% Uv                       = U(proj.c(:)./proj.lambda,Lsp(:));
% Welf                     = proj.lambda'*Uv;
% str = ['Welf = ',num2str(Welf,formatSpec),';\n\n']; fprintf(fid, str);

str    = ['Fu = ((r + delta)/alpha)*((1 - alpha)/(phil*L))*((1-U)/U)*(tau*(1+phil)-1)* (\n']; fprintf(fid, str);
for j = 1:Ntot/2
         str = ['+PSI',num2str(j),'*S',num2str(j),'*l',num2str(yv(j)),'*',num2str(states(yv(j)))]; fprintf(fid, str);   
         if mod(j,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
         end;
 end;
 str = [');\n\n']; fprintf(fid, str); 

 str    = ['Fe = ((r + delta)/alpha)*((1 - alpha)/(phil*L))*(1 - tau)* (\n']; fprintf(fid, str);
for j = Ntot/2+1:Ntot
         str = ['+PSI',num2str(j),'*S',num2str(j),'*l',num2str(yv(j)),'*',num2str(states(yv(j)))]; fprintf(fid, str);   
         if mod(j,10)==0; %multiple de 10
             str = ['\n'] ;         fprintf(fid, str);
         end;
 end;
 str = [');\n\n']; fprintf(fid, str); 


str     = ['PHI  ','   = ',num2str(PHI),';\n']; fprintf(fid, str);

% 
 str = ['s =',num2str(means,formatSpec),';\n'] ; fprintf(fid, str);  
 str = ['f =',num2str(meanf,formatSpec),';\n'] ; fprintf(fid, str);  
% 
% 
str = ['Cu = ']; fprintf(fid, str);
for i = 1:Ntot/2
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' \n\n']; 
str = ['Ce = ']; fprintf(fid, str);
for i = Ntot/2+1:Ntot
      str    = ['+S',num2str(i),'*c',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'];fprintf(fid, str);str = [' \n\n']; fprintf(fid, str); 
str = ['C = Ce + Cu;'] ;         fprintf(fid, str);str = [' \n\n']; fprintf(fid, str); 
str = ['cec = Ce/(1-U);'] ;      fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); 
str = ['cuc = Cu/U;'] ;          fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); 
str = ['ratio = cuc/cec;'] ;       fprintf(fid, str);str = [' \n\n']; fprintf(fid, str); 

%%%% optimal
str = ['AE = ',num2str(plans.AE,formatSpec),';\n' ]; fprintf(fid, str); % to set PHI constant
str = ['AU = ',num2str(plans.AU,formatSpec),';\n' ]; fprintf(fid, str); % to set PHI constant
str = ['Sum1 = ',num2str(plans.sum1,formatSpec),';\n' ]; fprintf(fid, str); % to set PHI constant
str = ['Sum2 = ',num2str(plans.sum2,formatSpec),';\n' ]; fprintf(fid, str); % to set PHI constant
str = ['DIF = Sum1 + AE - AU ;']; fprintf(fid, str);

%str = ['PHI =tau*(1-U)/U;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   

%str = ['DIF = steady_state(DIF);']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1; % steady-state operator to avoid 
str = ['Ku = ']; fprintf(fid, str);
for i = 1:Ntot/2
     str    = ['+S',num2str(i),'*ap',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;          fprintf(fid, str);str = ['\n\n']; fprintf(fid, str); 

str = ['Incu = (1/U)*( ']; fprintf(fid, str);
for i = 1:Ntot/2
      %str    = ['+S',num2str(i),'*(0*PHI*w*',num2str(bewley.ex(yv(i)),formatSpec),'*l',num2str(yv(i)),' + (1+r)*at',num2str(i),')']; fprintf(fid, str);
      str    = ['+S',num2str(i),'*(1+r)*at',num2str(i)]; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [');\n'] ;         fprintf(fid, str);
str = ['kuc = Ku/U;\n'] ;         fprintf(fid, str);



str = ['du = 0;\n']; fprintf(fid, str); 
str = ['dY = 0;\n']; fprintf(fid, str); 
str = ['dK = 0;\n']; fprintf(fid, str); 
str = ['dC = 0;\n']; fprintf(fid, str); 
str = ['dL = 0;\n']; fprintf(fid, str); 
str = ['Ineq = 0;\n']; fprintf(fid, str); 
str = ['df = 0;\n']; fprintf(fid, str); 
str = ['dU = 0;\n']; fprintf(fid, str); 
str = ['dphi = 0;\n']; fprintf(fid, str); 

str = ['I =  delta*K;\n']; fprintf(fid, str); 


str = ['LGDP = log(GDP);']; fprintf(fid, str); 
str = ['LC   = log(C);']; fprintf(fid, str);
str = ['LI   = log(I);']; fprintf(fid, str);
str = ['LL   = log(L);']; fprintf(fid, str);
str = ['Lw   = log(w);']; fprintf(fid, str);

str = ['Lwu   = log(PHI*w);']; fprintf(fid, str); 
str = ['Lwe   = log((1-tau)*w);']; fprintf(fid, str); 


str = ['end;\n\n'] ; fprintf(fid, str);     

str = ['resid;\n\n'] ; fprintf(fid, str); 


str = ['steady(nocheck);\n\n'] ; fprintf(fid, str); 
str = ['shocks;\n var eps; stderr ',num2str(sigma_u,formatSpec),';\n end;\n'] ; fprintf(fid, str);         


str = ['stoch_simul (qz_zero_threshold = 1e-20,order=1,irf=100, nograph, periods = 10000)  u GDP C w L I f U PHI;'] ; fprintf(fid, str);    

%%%%%%%% run DYNARE %%%%%%%


dynare Dynare_ramsey.mod

    